import { __classPrivateFieldGet, __classPrivateFieldSet } from "tslib";
export const LifecycleMixin = (Base) => { var _instances, __container, __tryFindContainingLayout, _a; return _a = class extends Base {
        constructor(...args) {
            super(args);
            _instances.add(this);
            __container.set(this, { _key: 'dom' });
        }
        cloneNode(deep) {
            const thisClone = this.deepClone();
            if (deep) {
                Array.from(this.childNodes).forEach((child) => {
                    thisClone.appendChild(child.cloneNode(true));
                });
            }
            return thisClone;
        }
        deepClone() {
            const copy = document.createElement(this.tagName.toLowerCase());
            this.getAttributeNames().forEach((at) => copy.setAttribute(at, this.getAttribute(at)));
            return copy;
        }
        get shouldRunDisconnect() {
            if (__classPrivateFieldGet(this, __container, "f")._key === 'dom') {
                return true;
            }
            if (__classPrivateFieldGet(this, __container, "f")._key === 'foundation-layout-cache') {
                return false;
            }
            return !(__classPrivateFieldGet(this, __container, "f").dragging || !__classPrivateFieldGet(this, __container, "f").hasFirstLoaded);
        }
        get shouldRunConnect() {
            return this.shouldRunDisconnect;
        }
        connectedCallback() {
            super.connectedCallback();
            if (__classPrivateFieldGet(this, __container, "f")._key !== 'foundation-layout') {
                __classPrivateFieldSet(this, __container, __classPrivateFieldGet(this, _instances, "m", __tryFindContainingLayout).call(this, this), "f");
            }
        }
    },
    __container = new WeakMap(),
    _instances = new WeakSet(),
    __tryFindContainingLayout = function __tryFindContainingLayout(e) {
        if (e.getRootNode()[layoutCacheDocument] === true) {
            return { _key: 'foundation-layout-cache' };
        }
        if (e.getRootNode() instanceof Document) {
            return { _key: 'dom' };
        }
        const shadowHost = e.getRootNode().host;
        if (shadowHost.constructor.name === 'FoundationLayout') {
            const layoutHost = shadowHost;
            layoutHost._key = 'foundation-layout';
            return layoutHost;
        }
        return __classPrivateFieldGet(this, _instances, "m", __tryFindContainingLayout).call(this, shadowHost);
    },
    _a; };
export const layoutCacheDocument = Symbol('layout-cache-document');
